<?php

namespace App\Console\Commands;

use Carbon\Carbon;
use DB;
use Illuminate\Console\Command;

class HandleLocations extends Command
{

    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'handle:location';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'handle locations jobs';

     /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    { 
        parent::__construct();
    }

    public function handle()
    {
        $message = $this->handle_request();
        dd($message);
    }

    
    private function handle_request()
    {
        $res = [];
        $location_msg = [];
        $check_user = [];
        $location_jobs = DB::table('location_jobs')->where('is_handle', 0)->get();
       
            foreach ($location_jobs as $jobs) {
                $check_user = $this->check_user($jobs->membership_number); //check if the membership_number exist
                //array_push($res, $check_user);
                if($check_user){
                    $last_sent_msg = $this->get_lastmsg($jobs->membership_number, $jobs->location_id);// get the last message sent to the membership_number from the location
                  
                    $next_priority_message = $this->next_priority($last_sent_msg->location_id, $last_sent_msg->priority); // get next priority message to be sent
                     array_push($res, $next_priority_message);
                    if(!is_null($next_priority_message)){
                        $get_medium = $this->used_medium($last_sent_msg->location_id); //get active medium
                       // array_push($res, $get_medium);
                        $check_interval = $this->check_interval($last_sent_msg->created_at, $get_medium);  //check the interval of the last message sent base on the medium
                        if($check_interval){
                            // true (send a new message)
                            $msg = [
                                'message'=> 'send next priority message',
                                'membership_number' => $jobs->membership_number,
                                'location_msg'=> $next_priority_message,
                                'res'=> true
                            ];
                            
                             array_push($res, $msg);
                        }else{
                            //false(do not send)
                            $msg = [
                                'message'=> 'Last message interval as not elapse',
                                'membership_number'=> $jobs->membership_number,
                                'res'=> false
                            ];
                            array_push($res, $msg);
                        }
                    }else{
                        //check reset interval
                        $reset = [];
                        $get_medium = $this->used_medium($last_sent_msg->location_id); //get active medium
                         //array_push($res, $get_medium);
                         $reset_interval = $this->reset_interval($last_sent_msg->created_at, $get_medium);
                         //array_push($res, $reset_interval);
                        if($reset_interval){
                            //true(start afresh)
                            $first_priority = $this->first_priority($last_sent_msg->location_id);
                            //array_push($res, $first_priority);
                            //$sent_message = $this->sent_message($jobs->membership_number,$first_priority);
                            $msg = [
                                'message'=> 'send highest priority message',
                                'membership_number' => $jobs->membership_number,
                                'location_msg'=> $first_priority,
                                'res'=> true
                            ];
                            //$sent = $this->sent_message($jobs->membership_number,$next_priority_message);
                             array_push($res, $msg);
                            //array_push($res, $sent_message);
                        }else{
                            //false(do not start afresh)
                            $msg = [
                                'message'=> 'Last message reset interval as not elapse',
                                'membership_number'=> $jobs->membership_number,
                                'res'=> false
                            ];
                            array_push($res, $msg);
                        }

                    }
                }else{
                    $location_message = $this->get_message($jobs->location_id);
                    $msg = [
                        'message'=> 'Send first message to the new membership number',
                        'membership_number'=> $jobs->membership_number,
                        'msg'=> $location_message,
                        'res'=> true
                    ];

                    array_push($res, $msg);

                }
                
            }
            return $res;

           
    }
   
    
    private function get_message($location){
        
        
        $highest_priority = DB::table('messages')->where('location_id', $location)
                                                    ->where('status', 1)
                                                    ->min('priority');
        return DB::table('messages')->where('location_id', $location)
                                    ->where('priority', $highest_priority)
                                    ->get();
    }

    private function check_user($membership_number)
    {
        return DB::table('sent_messages')->where('member_number', $membership_number)->exists();
    }

    private function used_medium($location_id)
    {
        return DB::table('location_msg_medium')->where('location_id', $location_id)->get();
    }

    private function get_lastmsg($membership_number, $location_id)
    {
      
        $last_id = DB::table('sent_messages')->where('member_number', $membership_number)->where('location_id', $location_id)->max('id');
        return DB::table('sent_messages')->where('id', $last_id)->first();
        
    }

    private function next_priority($location_id, $last_priority)
    {
        $next_priority = intval($last_priority + 1);
        return DB::table('messages')->where('location_id', $location_id)
                                        ->where('priority', $next_priority)
                                        ->first();
    }
    
    private function check_interval($lastmsg_sent_time, $interval)
    {
        $msg = [];
        $dt = Carbon::parse($lastmsg_sent_time);
        foreach ($interval as $set_interval) {
          $time_interval = $dt->addHours($set_interval->msg_interval);
          if($lastmsg_sent_time < $time_interval){
              //array_push($msg, false);
                return false;
          }else{
            //array_push($msg, true);
                return true;
          }

          return $msg;
        }
     
       
        
    }

    private function reset_interval($last_sent_time, $interval)
    {
        $msg = [];
        $dt = Carbon::parse($last_sent_time);
        foreach ($interval as $set_interval) {
            $time_interval = $dt->addHours($set_interval->reset_interval);
            if($last_sent_time < $time_interval){
                array_push($msg, false);
            }else{
                array_push($msg, true);
            }
        }

        return $msg;
       
        
        
       
       
    }

    private function first_priority($location_id)
    {
        $msg_priority = DB::table('messages')->where('location_id', $location_id)->min('priority');
        //return $msg_priority;
        return DB::table('messages')->where('priority', $msg_priority)->first();
    }

    private function sent_message($membership_number, $message)
    {
        DB::table('sent_messages')->where('membership_number', $membership_number)->insert([
            'location_id'=> $message->location_id,
            'message_id'=> $message->id,
            'member_number'=> $membership_number,
            'priority'=> $message->priority,
        ]);
         $data = [
            'membership_number'=> $membership_number,
            'message'=> $message,
        ];
        return $data;
    }

    


}