<?php

namespace App\Console\Commands;

use App\Jobs\SearchLocation;
use Carbon\Carbon;
use DB;
use Illuminate\Console\Command;

class distanceSearch extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'distance:search';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'run a distance search';

    protected $program_locations = [];
    protected $errors = [];
    protected $msg = [];

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    { 
        parent::__construct();
    }

    public function handle()
    {
        $datares = [];
       $results = $this->handle_search();
        
       if(!empty($results)){
        $distance_results = $this->get_result($results);
        dd($distance_results);
       }else{
         dd('No location found');
       }
      // dd($results);
       

      

    }


    private function handle_search()
    {
        $locations = [];
        $res = [];
        $messages = [];
       
        //get all users_request
        $jobs = DB::table('users_request')->where('is_handle', 0)->get();
        foreach ($jobs as $request) {
            $this->program_locations = DB::table('locations')->where('program_id', $request->program_id)
                                                                ->where('status', 1)
                                                                ->get();
            //array_push($locations, $this->program_locations);
            $results = $this->RadiusBaseSearch($this->program_locations, $request->latitude, $request->longitude, $request->membership_number);
            
            array_push($res, $results);
            
        }

        return $res;
       
    }

    private function get_result($results)
    {
        foreach ($results as $res) {
            foreach($res as $jobs){
                if(!empty($jobs['loc'])){
                    //store the membership_numbers and locations
                $store_locations = DB::table('location_jobs')->insert([
                    'membership_number' => $jobs['membership_number'],
                    'location_id' => $jobs['loc']->id
                ]);

                $update_userlog = DB::table('users_request')->where('membership_number', $jobs['membership_number'])->update([
                    'is_handle' => 1
                ]);

                $msg = [
                    'message'=> 'Program locations',
                    'program_id'=> $jobs['loc']->program_id,
                    'membership_number'=> $jobs['membership_number'],
                    'set_distance'=> $jobs['loc']->radius,
                    'cal_distance' => $jobs['cal_distance'],
                    'found_location'=> $jobs['loc']->id,
                    'res'=> true
                ];
                array_push($datares, $msg);
            
            }else{
                //log no location found for the request
                $update_userlog = DB::table('users_request')->where('membership_number', $jobs['memmbership_number'])->update([
                    'is_handle' => 1
                ]);

                $msg = [
                    'message'=> 'No location found',
                    'program_id'=> $jobs['loc']->program_id,
                    'membership_number'=> $jobs['loc']->member_id,
                    'res'=> false
                ];
                array_push($datares, $msg);
            }

            }
        
    }

    return $datares;
    }

     /**
     * Search for "program" locations 
     * @param locations program locations in the database
     * @param lat user latitude
     * @param long user longitude
     * @param radius user radius
     * 
     * 
     * @return float in KM
     */
    private function RadiusBaseSearch($locations, $lat, $long, $membership_number)
    {
        $results = [];
        foreach ($locations as $loc) {
            $R = 6371;
            $dLat = deg2rad($lat - $loc->latitude);
            $dLon = deg2rad($long - $loc->longitude);
            $angle = sin($dLat/2) * sin($dLat/2) + cos(deg2rad($lat)) * cos(deg2rad($loc->latitude)) * sin($dLon/2) * sin($dLon/2);
            $c = 2 * atan2(sqrt($angle), sqrt(1-$angle));
            $d = $R * $c; //Distance in KM
            if($d <= $loc->radius){
               // $combine_res = $collect->combine([$membership_number, $loc, $d]);
               $combine_res = [
                    'membership_number'=> $membership_number,
                    'loc'=> $loc,
                    'cal_distance'=> $d
               ];
                array_push($results, $combine_res);
            }  
        }
        return $results;
    }

   
   
    




   

   
       
}