<?php

namespace App\Http\Controllers;

use App\Helpers;
use App\Jobs\messageHandler;
use App\Jobs\SearchLocation;
use App\Models\Location;
use App\Models\Message;
use App\Models\Program_Setting;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use LaravelFCM\Message\OptionsBuilder;
use LaravelFCM\Message\PayloadDataBuilder;
use LaravelFCM\Message\PayloadNotificationBuilder;
use LaravelFCM\Facades\FCM;

class DistanceSearchController extends Controller
{

    protected $message;


    public function resolveDistance(Request $request)
    {
        $this->validate($request, [
            'latitude'=> 'required|numeric|between:-180,180',
            'longitude' => 'required|numeric|between:-180,180',
            'membership_number'=> 'required|alpha_num|max:255'
        ]);


       $program = DB::table('programs')->where('token', $request->header('token'))->first();
       $store = DB::table('users_request')->insert([
           'longitude'=> $request['longitude'],
           'latitude'=> $request['latitude'],
           'membership_number'=> $request['membership_number'],
           'program_id'=> $program->id
       ]);

       if($store){
        return response()->json(['message'=> 'Data collected successfully', 'status'=>$store, 'status_code'=> Helpers::STATUSCODE_SUCCESS],  Helpers::STATUSCODE_SUCCESS);
       }else{
        return response()->json(['message'=> 'invaild request', 'status'=>$store, 'status_code'=> Helpers::STATUSCODE_FAILED],  Helpers::STATUSCODE_FAILED);
       }

     
        

    }


}