<?php

namespace App\Models;

use Illuminate\Support\Facades\DB;

class Location 
{
    
    public static function all($status, $limit, $program)
    {
        if(is_null($status)){
            return DB::table('locations')->where('program_id', $program)->paginate($limit);
        }else{
            return DB::table('locations')->where('program_id', $program)->where('status', $status)->paginate($limit);
        }
       
    }

    public static function create_location($data)
    {
        return DB::table('locations')->insert($data);
    }

    public static function find_location($id)
    {
        return DB::table('locations')->find($id);
    }

    public static function update_location($id, $data)
    {
        return DB::table('locations')->where('id', $id)->update($data);
    }

    public static function location_to_program($data)
    {
        return DB::table('program_locations')->insert($data);
    }

    public static function all_branches($status)
    {
        if(is_null($status)){
            return DB::table('program_locations')->get();
        }else{
            return DB::table('program_locations')->where('status', $status)->get();
        }
     
    }
    public static function update_branch($id, $data)
    {
        return DB::table('program_locations')->where('id', $id)->update($data);
    }

    public static function find_branch($id)
    {
        return DB::table('program_locations')->where('location_id',$id)->get();
    }

    public static function delete_branch($id)
    {
        return DB::table('program_locations')->where('id', $id)->delete();  
    }

    public static function location_details($slug)
    {
        return DB::table('locations')->where('slug', $slug)->first();
    }

    public static function LocationExits($id){
        return DB::table('locations')->where('id', $id)->exists();
    }

    public static function programlocation_exists($program_id, $location_id)
    {
        return DB::table('program_locations')->where('loyalty_program_id', $program_id)
                                            ->where('location_id', $location_id)
                                            ->exists();
    }
}