<?php

namespace App\Models;

use Illuminate\Support\Facades\DB;

class Message 
{

    
    public static function all_messages($status, $program)
    {
        
        if(is_null($status)){
            return DB::table('messages')->where('loyalty_program_id', $program)->get();
        }else{
            return DB::table('messages')->where('loyalty_program_id', $program)->where('status', $status)->get();
        }
    }

    public static function create_message($data)
    {
        return DB::table('messages')->insert($data);
    }

    public static function update_message($id, $data)
    {
       
        return DB::table('messages')->where('id', $id)->update($data);
            
    }

    public static function show_message($id)
    {
        return DB::table('messages')->find($id);
    }

    public static function Message_to_Location($data)
    {
        return DB::table('location_message')->insert($data);
    }

    public static function show_location_message($id)
    {
        return DB::table('location_message')->where('location_id',$id)->get();
    }

    public static function update_location_message($id, $data)
    {
        return DB::table('location_message')->where('id', $id)->update($data);
    }

    public static function all_location_messages($status)
    {
        if(is_null($status)){
            return DB::table('location_message')->get();
        }else{
            return DB::table('location_message')->where('status', $status)->get();
        }
    }

    public static function message_details($slug)
    {
        return DB::table('messages')->where('slug', $slug)->first();
    }

    public static function message_exists($id)
    {
        return DB::table('messages')->where('id', $id)->exists();
    }

    public static function LocationMessage_Exist($location_id, $message_id)
    {
        return DB::table('messages')->where('id', $message_id)
                                ->where('location_id', $location_id)
                                ->exists();
    }
}