<?php

namespace App\Models;

use Illuminate\Support\Facades\DB;

class Program_Setting 
{

    public static function all($status, $limit)
    {
        if(is_null($status)){
            return DB::table('program_settings_master')->select('id', 'program_name', 'maximum_distance', 'message_interval', 'message_medium', 'status', 'created_at', 'updated_at')->paginate($limit);
        }else{
            return DB::table('program_settings_master')->where('status', $status)->select('id', 'program_name', 'maximum_distance', 'message_interval', 'message_medium', 'status', 'created_at', 'updated_at')->paginate($limit);
        }
       
    }
    public static function create($data)
    {
        
        return DB::table('program_settings_master')->insert($data);
    }

    public static function update($id, $data)
    {
        if(isset($data['message_medium'])){
            if(is_array($data['message_medium'])){
                $msg_medium = implode(',', $data['message_medium']);
            }else{
                $msg_medium = $data['message_medium'];
            }
            DB::table('program_settings_master')->where('id', $id)->update([
                'message_medium'=> $msg_medium
            ]);

            return DB::table('program_settings_master')->where('id', $id)->update($data);

        }else{
            return DB::table('program_settings_master')->where('id', $id)->update($data);
        }
       
    }

    public static function find($id)
    {
        return DB::table('program_settings_master')->where('loyalty_program_id', $id)->select('id','program_name', 'maximum_distance', 'message_interval', 'message_medium','status', 'created_at','updated_at')->first();
    }
    

}

