<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
*/

$router->group(['prefix'=> 'api/v1', 'middleware'=>'PreX'], function() use ($router){

    $router->get('/program/all[/{status}]', 'ProgramController@all');
    $router->post('/program/add', 'ProgramController@store');
    $router->get('/program/{program_slug}', 'ProgramController@show');
    $router->put('/program/update/{program_slug}', 'ProgramController@update');
    $router->get('/program/enable/{program_slug}', 'ProgramController@enable');
    $router->get('/program/disable/{program_slug}', 'ProgramController@disable');


});

$router->group(['prefix'=> 'api/v1', 'middleware'=> 'auth'], function() use ($router) {

   
    //program setting
    $router->get('/program_setting/all[/{status}]', 'ProSettingsController@settings');
    $router->post('/program_setting/add', 'ProSettingsController@program_setting');
    $router->put('/program_setting/update/{program_slug}', 'ProSettingsController@update_program_setting');
    $router->get('/program_setting/{program_slug}', 'ProSettingsController@find_program_setting');
    $router->get('/program_setting/disable/{program_slug}', 'ProSettingsController@disable_program_setting');
    $router->get('/program_setting/enable/{program_slug}', 'ProSettingsController@enable_program_setting');

    $router->get('/location/all[/{status}]', 'LocationController@all');
    $router->post('/location/add', 'LocationController@store');
    $router->put('/location/update/{location_slug}', 'LocationController@update');
    $router->get('/location/find/{location_slug}', 'LocationController@show');
    $router->get('/locations[/{status}]', 'LocationController@all');
    $router->get('/location/disable/{location_slug}', 'LocationController@disable');
    $router->get('/location/enable/{location_slug}', 'LocationController@enable');
    //$router->post('/programlocation/assign', 'LocationController@create_branch');
    //$router->put('/programlocation/update/{location_slug}', 'LocationController@update_branch');
    //$router->get('/programlocation/all[/{status}]', 'LocationController@branches');
    //$router->get('/programlocation/find/{location_slug}', 'LocationController@find_branch');
    //$router->delete('/programlocation/delete/{location_slug}', 'LocationController@delete_branch');

    $router->get('/message/all[/{status}]', 'MessageController@all');
    $router->post('/message/create', 'MessageController@store');
    $router->get('/message/find/{id}', 'MessageController@show'); //use more of id 
    $router->put('/message/edit/{id}', 'MessageController@update'); // use more of id
    $router->get('/message/disable/{message_slug}', 'MessageController@disable');
    $router->get('/message/enable/{message_slug}', 'MessageController@enable');
    
    $router->post('/locationmessage/assign', 'MessageController@assign_to_location');
    $router->put('/locationmessage/update/{location_slug}/{message_id}', 'MessageController@update_location_message');
    $router->get('/locationmessage/find/{location_slug}/{message_id}', 'MessageController@find_location_message');
    $router->get('/locationmessage/{location_slug}/all_messages', 'MessageController@location_message');
    $router->get('/locationmessage/all[/{status}]', 'MessageController@all_location_message');
    $router->get('/locationmessage/disable/{location_slug}', 'MessageController@disable_location_message');
    $router->get('/locationmessage/enable/{location_slug}', 'MessageController@enable_location_message');


    $router->post('/getdistances', 'DistanceSearchController@resolveDistance');
    //$router->get('/sendmessages/{location_slug}', 'DistanceSearchController@getmessages');
    //Log data
    $router->get('/logs/all', 'LogActivity@all');
    $router->get('/log/{slug}', 'LogActivity@find');

    //max distance enpoints
    // $router->get('/maxdistance/all', 'MaxDistanceController@all_distances');
    // $router->post('/maxdistance/new', 'MaxDistanceController@new_distance');
    // $router->put('/maxdistance/update/{distance_slug}', 'MaxDistanceController@update_distance');
    // $router->delete('/maxdistance/{distance_slug}', 'MaxDistance@delete_distance');

    
});